diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
index 0f4921048..75f5ac56c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
@@ -10,12 +10,13 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -28,7 +29,7 @@ public class BlockLogicFlower
     public boolean canBeBonemealed = false;
 
     public BlockLogicFlower(final @NotNull Block<?> block) {
-        super(block, Material.plant);
+        super(block, Materials.PLANT);
         block.setTicking(true);
         final float f = 0.2F;
         this.setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 3F, 0.5F + f);
@@ -45,17 +46,17 @@ public class BlockLogicFlower
     }
 
     @Override
-    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         return MASK_PERMANENT;
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
-        return super.canPlaceAt(world, tilePos) && this.mayPlaceOn(world.getBlockId(tilePos.down()));
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return super.canPlaceAt(world, tilePos) && this.mayPlaceOn(world.getBlockId(tilePos.down(new TilePos())));
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
@@ -65,13 +66,13 @@ public class BlockLogicFlower
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         super.onNeighborChanged(world, tilePos, id);
         this.checkAlive(world, tilePos);
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         this.checkAlive(world, tilePos);
 
         if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getSeasonManager().getCurrentSeason() != null && (!isPermanent(world.getBlockData(tilePos))) && world.getSeasonManager().getCurrentSeason().killFlowers && this.killedByWeather && rand.nextInt(256) == 0) {
@@ -79,7 +80,7 @@ public class BlockLogicFlower
         }
     }
 
-    protected final void checkAlive(final @NotNull World world, final @NotNull TilePos tilePos) {
+    protected final void checkAlive(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (!this.canStay(world, tilePos)) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
@@ -87,8 +88,8 @@ public class BlockLogicFlower
     }
 
     @Override
-    public boolean canStay(final @NotNull World world, final @NotNull TilePos tilePos) {
-        return (world.getFullBlockLightValue(tilePos) >= 8 || world.canBlockSeeSky(tilePos)) && this.mayPlaceOn(world.getBlockId(tilePos.down()));
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return (world.getFullBlockLightValue(tilePos) >= 8 || world.canBlockSeeSky(tilePos)) && this.mayPlaceOn(world.getBlockId(tilePos.down(new TilePos())));
     }
 
     public static boolean isPermanent(final int metadata) {
@@ -100,7 +101,7 @@ public class BlockLogicFlower
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return null;
     }
 
@@ -115,7 +116,7 @@ public class BlockLogicFlower
     }
 
     @Override
-    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         final Random rand = world.rand;
         if (!world.isClientSide && this.canBeBonemealed && itemStack.consumeItem(player)) {
             {
@@ -127,30 +128,31 @@ public class BlockLogicFlower
                 }
             }
 
-            label0:
+            TilePos queryPos = new TilePos();
+            outer:
             for (int i = 0; i < 128; i++) {
-                final @NotNull TilePos localPos = new TilePos(tilePos);
+                int checkX = tilePos.x();
+                int checkY = tilePos.y();
+                int checkZ = tilePos.z();
                 for (int j = 0; j < i / 16; j++) {
-                    localPos.x += rand.nextInt(3) - 1;
-                    localPos.y += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
-                    localPos.z += rand.nextInt(3) - 1;
-                    final int blockId = world.getBlockId(localPos.down());
+                    checkX += rand.nextInt(3) - 1;
+                    checkY += ((rand.nextInt(3) - 1) * rand.nextInt(3)) / 2;
+                    checkZ += rand.nextInt(3) - 1;
+                    final int blockId = world.getBlockId(queryPos.set(checkX, checkY - 1, checkZ));
                     if (!this.mayPlaceOn(blockId)) {
-                        continue label0;
+                        continue outer;
                     }
                 }
 
-                final @Nullable Block<?> b = world.getBlock(localPos);
+                final @Nullable Block<?> b = world.getBlock(queryPos.set(checkX, checkY, checkZ));
                 if (Block.hasLogicClass(b, BlockLogicFlowerStackable.class)) {
-                    final int meta = world.getBlockData(localPos);
+                    final int meta = world.getBlockData(queryPos.set(checkX, checkY, checkZ));
                     if (BlockLogicFlowerStackable.getStackCount(meta) < BlockLogicFlowerStackable.MAX_STACK_COUNT) {
-                        world.setBlockDataNotify(localPos, BlockLogicFlowerStackable.setStackCount(meta, BlockLogicFlowerStackable.getStackCount(meta) + 1));
+                        world.setBlockDataNotify(queryPos.set(checkX, checkY, checkZ), BlockLogicFlowerStackable.setStackCount(meta, BlockLogicFlowerStackable.getStackCount(meta) + 1));
                     }
-                } else if (b != null) {
-                    continue;
-                } else {
+                } else if (b == null) {
                     if (rand.nextFloat() > 0.75) {
-                        world.setBlockIdNotify(localPos, this.block.id());
+                        world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlowerStackable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlowerStackable.java
index a72c5d039..a75ae2dd4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlowerStackable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlowerStackable.java
@@ -7,7 +7,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -24,7 +24,7 @@ public class BlockLogicFlowerStackable extends BlockLogicFlower {
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         final int metadata = itemStack.getMetadata();
         return setPermanent(metadata, true);
     }
@@ -43,7 +43,7 @@ public class BlockLogicFlowerStackable extends BlockLogicFlower {
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         final int metadata = world.getBlockData(tilePos);
         final int currentStackCount = getStackCount(metadata);
         if (currentStackCount >= MAX_STACK_COUNT) {
@@ -57,7 +57,7 @@ public class BlockLogicFlowerStackable extends BlockLogicFlower {
 
         final int newMetadata = setPermanent(setStackCount(metadata, currentStackCount + 1), true);
         world.setBlockDataNotify(tilePos, newMetadata);
-        world.playBlockSoundEffect(player, tilePos.x + 0.5f, tilePos.y + 0.5f, tilePos.z + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
+        world.playBlockSoundEffect(player, tilePos.x() + 0.5f, tilePos.y() + 0.5f, tilePos.z() + 0.5f, this.block, EnumBlockSoundEffectType.PLACE);
         heldItem.consumeItem(player);
         return true;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index 7ec54d766..757768063 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -9,13 +9,16 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -36,7 +39,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
         return (float) (data + 1) / 8F;
     }
 
-    protected int getDepth(final WorldSource worldSource, final @NotNull TilePos tilePos) {
+    protected int getDepth(final WorldSource worldSource, final @NotNull TilePosc tilePos) {
         if (worldSource.getBlockMaterial(tilePos) != this.material) {
             return -1;
         } else {
@@ -44,7 +47,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
         }
     }
 
-    protected int getRenderedDepth(final @NotNull WorldSource worldSource, final @NotNull TilePos tilePos) {
+    protected int getRenderedDepth(final @NotNull WorldSource worldSource, final @NotNull TilePosc tilePos) {
         if (worldSource.getBlockMaterial(tilePos) != this.material) {
             return -1;
         }
@@ -66,7 +69,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
@@ -76,50 +79,47 @@ public abstract class BlockLogicFluid extends BlockLogic {
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
-    private Vec3 getFlow(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
-        Vec3 result = Vec3.fromPool(0.0D, 0.0D, 0.0D);
-        final int depthLocal = getRenderedDepth(source, tilePos);
-        TilePos p = new TilePos(tilePos);
+    private @NotNull Vector3dc getFlow(@NotNull WorldSource world, @NotNull TilePosc tilePos) {
+        Vector3d result = new Vector3d();
+        TilePos queryPos = new TilePos();
+        int depthLocal = getRenderedDepth(world, tilePos);
         for (int i = 0; i < 4; i++) {
-            p.set(tilePos.x, tilePos.y, tilePos.z);
+            int checkX = tilePos.x();
+            int checkY = tilePos.y();
+            int checkZ = tilePos.z();
             switch (i) {
-                case 0 -> tilePos.x--;
-                case 1 -> tilePos.z--;
-                case 2 -> tilePos.x++;
-                case 3 -> tilePos.z++;
+                case 0 -> checkX--;
+                case 1 -> checkZ--;
+                case 2 -> checkX++;
+                case 3 -> checkZ++;
             }
-
-            int depthCheck = getRenderedDepth(source, p);
+            int depthCheck = getRenderedDepth(world, queryPos.set(checkX, checkY, checkZ));
             if (depthCheck < 0) {
-                if (source.getBlockMaterial(p).blocksMotion()) {
+                if (world.getBlockMaterial(queryPos.set(checkX, checkY, checkZ)).blocksMotion()) {
                     continue;
                 }
-                depthCheck = getRenderedDepth(source, p.down());
+                depthCheck = getRenderedDepth(world, queryPos.set(checkX, checkY - 1, checkZ));
                 if (depthCheck >= 0) {
-                    final int mult = depthCheck - (depthLocal - 8);
-                    result = result.add((p.x - tilePos.x) * mult, 0, (p.z - tilePos.z) * mult);
+                    int mult = depthCheck - (depthLocal - 8);
+                    result = result.add((checkX - tilePos.x()) * mult, (checkY - tilePos.y()) * mult, (checkZ - tilePos.z()) * mult);
                 }
+                continue;
             } else {
-                final int mult = depthCheck - depthLocal;
-                result = result.add((p.x - tilePos.x) * mult, 0, (p.z - tilePos.z) * mult);
+                int mult = depthCheck - depthLocal;
+                result = result.add((checkX - tilePos.x()) * mult, (checkY - tilePos.y()) * mult, (checkZ - tilePos.z()) * mult);
             }
         }
-        result = result.normalize();
-        return result;
+        return result.normalize();
     }
 
     @Override
-    public void onEntityInside(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity, @NotNull Vec3 velocity) {
+    public void onEntityInside(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity, @NotNull Vector3d velocityDirection) {
         if (entity.noPhysics) return;
-        final Vec3 flowVector = getFlow(world, tilePos);
-
-        velocity.x += flowVector.x;
-        velocity.y += flowVector.y;
-        velocity.z += flowVector.z;
+        velocityDirection.add(getFlow(world, tilePos));
     }
 
     @Override
@@ -128,46 +128,46 @@ public abstract class BlockLogicFluid extends BlockLogic {
     }
 
     @Override
-    public float getBrightness(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public float getBrightness(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final float br = source.getLightBrightness(tilePos);
-        final float brAbove = source.getLightBrightness(tilePos.up());
+        final float brAbove = source.getLightBrightness(tilePos.up(new TilePos()));
         return Math.max(br, brAbove);
     }
 
     @Override
-    public void animationTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) {
+    public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         this.fluid.animationTick(this, world, tilePos, rand);
     }
 
-    public double getSlopeAngle(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
-        final Vec3 vec = getFlow(source, tilePos);
-        if (vec == null || (vec.x == 0.0D && vec.z == 0.0D)) {
+    public double getSlopeAngle(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
+        final Vector3dc vec = getFlow(source, tilePos);
+        if (vec.x() == 0.0D && vec.z() == 0.0D) {
             return -1000D;
         } else {
-            return Math.atan2(vec.z, vec.x) - Math.PI / 2;
+            return Math.atan2(vec.z(), vec.x()) - Math.PI / 2;
         }
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         checkForHarden(world, tilePos);
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         checkForHarden(world, tilePos);
     }
 
-    private void checkForHarden(final World world, final @NotNull TilePos tilePos) {
+    private void checkForHarden(final World world, final @NotNull TilePosc tilePos) {
         if (world.getBlockId(tilePos) != this.block.id()) {
             return;
         }
-
-        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.north()));
-        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.south()));
-        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.west()));
-        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.east()));
-        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.up()));
+        TilePos queryPos = new TilePos();
+        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.north(queryPos)));
+        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.south(queryPos)));
+        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.west(queryPos)));
+        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.east(queryPos)));
+        this.fluid.checkForHarden(this, world, tilePos, world.getBlockMaterial(tilePos.up(queryPos)));
     }
 
     @Override
@@ -175,38 +175,41 @@ public abstract class BlockLogicFluid extends BlockLogic {
         return null;
     }
 
-    protected static void fizz(final @NotNull World world, @NotNull TilePos tilePos) {
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x + 0.5F, (float) tilePos.y + 0.5F, (float) tilePos.z + 0.5F, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+    protected static void fizz(final @NotNull World world, @NotNull TilePosc tilePos) {
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
         for (int i = 0; i < 8; i++) {
-            world.spawnParticle("largesmoke", (double) tilePos.x + Math.random(), (double) tilePos.y + 1.2D, (double) tilePos.z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + 1.2D, (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         final float myHeight = getFluidHeight(source, tilePos);
-        final float heightPosZ = getFluidHeight(source, tilePos.add(0, 0, 1));
-        final float heightPosXPosZ = getFluidHeight(source, tilePos.add(1, 0, 1));
-        final float heightPosX = getFluidHeight(source, tilePos.add(1, 0, 0));
+        final float heightPosZ = getFluidHeight(source, tilePos.add(0, 0, 1, queryPos));
+        final float heightPosXPosZ = getFluidHeight(source, tilePos.add(1, 0, 1, queryPos));
+        final float heightPosX = getFluidHeight(source, tilePos.add(1, 0, 0, queryPos));
 
-        return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, Math.max((myHeight + heightPosZ + heightPosXPosZ + heightPosX) / 4f, 0.2), 1.0F);
+        return new AABBd(0.0F, 0.0F, 0.0F, 1.0F, Math.max((myHeight + heightPosZ + heightPosXPosZ + heightPosX) / 4f, 0.2), 1.0F);
     }
 
-    public float getFluidHeight(final @NotNull WorldSource worldSource, final @NotNull TilePos tilePos) {
+    public float getFluidHeight(final @NotNull WorldSource worldSource, final @NotNull TilePosc tilePos) {
         int count = 0;
         float height = 0.0F;
 
-        TilePos p = new TilePos(tilePos);
+        TilePos queryPos = new TilePos(tilePos);
         for (int i = 0; i < 4; i++) {
-            p.set(tilePos.x - (i & 1), tilePos.y, tilePos.z - (i >> 1 & 1));
-            if (worldSource.getBlockMaterial(p.up()) == this.material) {
+            int checkX = tilePos.x() - (i & 1);
+            int checkY = tilePos.y();
+            int checkZ = tilePos.z() - (i >> 1 & 1);
+            if (worldSource.getBlockMaterial(queryPos.set(checkX, checkY + 1, checkZ)) == this.material) {
                 return 1.0F;
             }
 
-            final Material adjMaterial = worldSource.getBlockMaterial(p);
+            final Material adjMaterial = worldSource.getBlockMaterial(queryPos.set(checkX, checkY, checkZ));
             if (adjMaterial == this.material) {
-                final int data = worldSource.getBlockData(p) & 0x0F;
+                final int data = worldSource.getBlockData(queryPos.set(checkX, checkY, checkZ)) & 0x0F;
                 if (data >= 8 || data == 0) {
                     height += BlockLogicFluid.getHeight(data) * 10F;
                     count += 10;
@@ -225,7 +228,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePos thisPos, @NotNull TilePos thatPos) {
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
         final Block<?> bBlock = world.getBlock(thatPos);
 
         final int thisMeta = world.getBlockData(thisPos);
